<%@ Page language="c#" Codebehind="testfixedheightgrid.aspx.cs" AutoEventWireup="false" Inherits="learncontrols.learngrid" %>
<%@ Register TagPrefix="aspx" Namespace="learncontrols" Assembly="learncontrols" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<TITLE>FixedHeightGrid</TITLE>
		<meta content="True" name="vs_showGrid">
		<meta content="Microsoft Visual Studio 7.0" name="GENERATOR">
		<meta content="C#" name="CODE_LANGUAGE">
		<meta content="JavaScript" name="vs_defaultClientScript">
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<style type="text/css">BODY { FONT-FAMILY: Verdana }
	.padding { HEIGHT: 14pt; BACKGROUND-COLOR: #f1f1f1 }
	.header { FONT-WEIGHT: bold; FONT-SIZE: 8pt; COLOR: white; HEIGHT: 14pt; BACKGROUND-COLOR: darkred }
	.item1 { FONT-SIZE: 8pt; HEIGHT: 14pt; BACKGROUND-COLOR: palegoldenrod }
	.item2 { FONT-SIZE: 8pt; HEIGHT: 14pt; BACKGROUND-COLOR: beige }
	INPUT.test { TEXT-ALIGN: right }
	.text { FONT-SIZE: 8pt }
	.numbers { TEXT-ALIGN: center }
	.pager { FONT-WEIGHT: bold; FONT-SIZE: 8pt; TEXT-ALIGN: left }
	.Info { FONT-SIZE: 8pt; COLOR: darkred }
	A { COLOR: darkred }
	A:visited { COLOR: darkred }
		</style>
	</HEAD>
	<body MS_POSITIONING="GridLayout">
		<form id="fixedheightgrid" method="post" runat="server">
			<asp:Label ID="LBLDescription" Runat="server">
				<span class="pager">ASP.NET DataGrid mit konstanter Zeilenzahl</span>
				<p class="text">
					The default DataGrid-WebControl shipped with the .NET-Framework already 
					is a powerful object to display and edit data in table form.<br>
					But when trying to implement the DataGrid in a fix programmed design 
					possibly the volatile behavior of the DataGrid which means<br> the 
					number of rows and with this the height of the DataGrid may vary 
					depending on the number of records to be displayed.
					<br><br>
					Marginal remedy could be done using the already implemented paging  
					the afore mentioned problem only shifts <br> mostly in inverted form  
					to the last page being displayed.<br><br>
					In order to solve the problem permanently, it is necessary to bore 
					up the DataGrid. And thats what well do in this article.<br>
					Given that the solution should be reusable, it is recommended 
					to encapsulate it in a webcontrol derived from the DataGrid.<br>
					<br>
					A sample of the implementation of the wanted solution is shown below.
				</p>
			</asp:Label>
			<table>
				<tr>
					<td>
						<table border="0" cellspacing="0" cellpadding="0" width="400">
							<tr>
								<td style="BORDER-RIGHT:black 1px solid; BORDER-TOP:black 1px solid; BORDER-LEFT:black 1px solid">
									<table cellpadding="1" cellspacing="1">
										<tr>
											<td class="info">&nbsp;Websites&nbsp;</td>
										</tr>
									</table>
								</td>
								<td style="BORDER-BOTTOM:black 1px solid" width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td colspan="2" style="BORDER-RIGHT:black 1px solid; BORDER-LEFT:black 1px solid; BORDER-BOTTOM:black 1px solid">
									<table cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td width="100%">
												<table border="0" width="100%">
													<tr>
														<td width="100%">
															<aspx:FixedHeightGrid id="mygrid" runat="server" OnPageIndexChanged="Grid_Paging" PagerStyle-Position="Bottom" CellSpacing="1" GridLines="None" AlternatingItemStyle-CssClass="item2" ItemStyle-CssClass="item1" PaddingItemStyle-CssClass="padding" MergePaddingColumns="False" PageSize="10" Width="100%" AutoGenerateColumns="False" PagerStyle-Mode="NumericPages" PagerStyle-HorizontalAlign="Left">
																<HeaderStyle CssClass="header" />
																<PagerStyle CssClass="pager" />
																<Columns>
																	<aspx:BoundColumn DataField="WebsiteID" HeaderText="ID"></aspx:BoundColumn>
																	<aspx:BoundColumn DataField="Website" HeaderText="Website"></aspx:BoundColumn>
																	<aspx:BoundColumn DataField="WebsiteOperator" HeaderText="Website-Operator"></aspx:BoundColumn>
																</Columns>
															</aspx:FixedHeightGrid>
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			<br>
			<table cellSpacing="0" cellPadding="0" border="0">
				<tr>
					<td><asp:checkbox id="CHBShowHeader" AutoPostBack="True" OnCheckedChanged="CHBShowHeader_CheckedChanged" Runat="server"></asp:checkbox></td>
					<td class="text">&nbsp;Show Header?</td>
				</tr>
				<tr>
					<td><asp:checkbox id="CHBShowFooter" AutoPostBack="True" OnCheckedChanged="CHBShowFooter_CheckedChanged" Runat="server"></asp:checkbox></td>
					<td class="text">&nbsp;Show Footer?</td>
				</tr>
				<tr>
					<td><asp:checkbox id="CHBAllowPaging" AutoPostBack="True" OnCheckedChanged="CHBAllowPaging_CheckedChanged" Runat="server"></asp:checkbox></td>
					<td class="text">&nbsp;Allow Paging?</td>
				</tr>
				<tr>
					<td colSpan="2"><asp:table id="TBLPagerOptions" CellSpacing="0" Runat="server" CellPadding="0">
							<asp:TableRow>
								<asp:TableCell>
									<asp:RadioButtonList ID="RALPagerOptions" Runat="server" CssClass="text" OnSelectedIndexChanged="RALPagerOptions_SelectedIndexChanged" AutoPostBack="True">
										<asp:ListItem>Top and Bottom</asp:ListItem>
										<asp:ListItem>Top only</asp:ListItem>
										<asp:ListItem>Bottom only</asp:ListItem>
									</asp:RadioButtonList>
								</asp:TableCell>
							</asp:TableRow>
						</asp:table></td>
				</tr>
				<tr>
					<td><asp:checkbox id="CHBPaddingStyle" AutoPostBack="True" OnCheckedChanged="CHBPaddingStyle_CheckedChanged" Runat="server"></asp:checkbox></td>
					<td class="text">&nbsp;Style PaddingItem = Style Standard-Item?</td>
				</tr>
				<tr>
					<td><asp:checkbox id="CHBMergePaddingColumns" AutoPostBack="True" OnCheckedChanged="CHBMergePaddingColumns_CheckedChanged" Runat="server"></asp:checkbox></td>
					<td class="text">&nbsp;Merge PaddingItem's columns?</td>
				</tr>
				<tr>
					<td colSpan="2">
						<table>
							<tr>
								<td class="text" colSpan="3">Rows / Page:</td>
							</tr>
							<tr>
								<td><asp:Button ID="BTNSubtract" Runat="server" Text="-" Width="30"></asp:Button></td>
								<td><asp:TextBox ID="TBXRowsCount" Runat="server" Width="50" CssClass="numbers" ReadOnly="True"></asp:TextBox></td>
								<td><asp:Button ID="BTNAdd" Runat="server" Text="+" Width="30"></asp:Button></td>
								<td width="100%"></td>
							</tr>
							<tr>
								<td class="text" colSpan="4">
									<asp:Label ID="LBLPagingInfo" Runat="server" CssClass="Info" Visible="False">The PageSize must only be changed on the first page!</asp:Label>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			<!--<asp:DataGrid ID="mydg" Runat="server"></asp:DataGrid>--></form>
	</body>
</HTML>
